/**
 * No Case Found error message
 */
export declare const NoCaseFound: string;
/**
 * Match statement
 * {{
 * Match( obj,
 *  Case( c => c === 'something', c => `c.toto`), ...
 * );
 * }}
 * @param a object to test
 * @param cases sets of cases to check.
 * @returns {B}
 * @throws 'no-case-found error' in case of no items match with cases.
 */
export declare function Match<A, B>(a: A, ...cases: Case<A, B>[]): B;
/**
 * Case statement.
 * @param test to check if the item is usable.
 * @param exec transform.
 */
export declare type Case<A, B> = {
    test: (o: A) => boolean;
    exec: (o: A) => B;
};
export declare function Case<A, B>(test: (o: A) => boolean, exec: (o: A) => B): Case<A, B>;
