/* tslint:disable:no-use-before-declare */
"use strict";
const Try_1 = require("./Try");
const MatchCase_1 = require("./MatchCase");
function PartialFunction(...cases) {
    return generate(arg => MatchCase_1.Match(arg, ...cases), arg => !!cases.find(c => c.test(arg)));
}
exports.PartialFunction = PartialFunction;
function orElse(a, b) {
    return generate(arg => a.isDefinedAt(arg) ? a(arg) : b(arg), arg => a.isDefinedAt(arg) || b.isDefinedAt(arg));
}
function andThen(a, b) {
    let resB;
    const f = (arg) => {
        if (!resB) {
            resB = a(arg);
        }
        return resB;
    };
    return generate(arg => b(f(arg)), arg => a.isDefinedAt(arg) && b.isDefinedAt(f(arg)));
}
function generate(f, find) {
    const res = (arg) => f(arg);
    res.isDefinedAt = (arg) => find(arg);
    res.orElse = (other) => orElse(res, other);
    res.andThen = (other) => andThen(res, other);
    res.lift = () => (arg) => Try_1.Try(() => f(arg)).toOptional();
    res.applyOrElse = (arg, orElse) => Try_1.Try(() => f(arg)).getOrElse(() => orElse(arg));
    return res;
}
